#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Ecrit par Jean-Baptiste Théou (Alias Anbreizh)
# Copyright 2005-2008 Jean-Baptiste Théou

    #################################
    #         EASYCAM               #
    #################################
#
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA 02111-1307 USA


### Recherche les webcams possèdant plusieur driver. 
### Map : Lit le dossier ./cams. Pour chaque webcam, recherche le nombre driver avec core.py -d

import sys
sys.path.append('/usr/lib/python%s/site-packages/oldxml' % sys.version[:3])

import xml.dom.minidom
from xml.dom.minidom import Node
import xml.dom.ext
import os
import re
import time
import easycamconfig

# subdirectory with ini files

subdir = "cams/"


##
# read one ini file and store info in XML node
#
# @param xmltree    XML tree to be created, needed for createElement function
# @param rootele    "easycam" element
# @param filename   filename of the ini file
# @param drivername "name" of the driver (e.g. spca, ov511, etc.)

def readini(filename,drivername):
	global cf
	global cnt
	# only use regular files
	if os.path.isdir(filename):
		return
	print "Reading ", filename, " for driver:", drivername	
	ein = open(filename,"r")
	for line in open(filename,"r"):
		line = line.rstrip()		# strip newline
		if line == "":			# don't process empty lines
			continue
		if line.startswith("#"):	# don't process comment lines
			continue
		# search for "ID xxxx:xxxx yadayadayada"
		ma = re.match("^ID\s([\da-zA-Z]{4}:[\da-zA-Z]{4})\s*($|(.*))",line)
		if ma:
			usbid = ma.group(1) # make ID lower case
			info = easycamconfig.ConfigInfo().getDriverListByID(usbid)[0]
			if len(info) > 1 :
				print usbid
		# everything else
		
	ein.close()

def mainloop():
	cnt = 0
	files = os.listdir('/usr/share/EasyCam2/tools/cams')
	for inifile in files:
		readini('/usr/share/EasyCam2/tools/cams/' + inifile,inifile)
	if cnt > 0:
		print "Easycam possède des doublons"
if __name__ == "__main__": 
	mainloop()

