#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Ecrit par Jean-Baptiste Théou (Alias Anbreizh)
# Copyright 2005-2008 Jean-Baptiste Théou

    #################################
    #         EASYCAM               #
    #################################
#
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA 02111-1307 USA

from optparse import OptionParser
import os,sys
import gettext
import commands
import easycamconfig

gettext.bindtextdomain("easycam","./locale")
gettext.textdomain("easycam")
_ = gettext.gettext


class Main:
	def __init__( self ):
	
		if not sys.argv[1:]:
        		sys.stdout.write (_(u"Sorry: you must specify at least an argument\n"))
        		sys.stdout.write(_(u"More help avalaible with -h or --help option\n"))
      			sys.exit(0)

		parser = OptionParser('Easycam [option]')
		parser.add_option("-i", "--install",dest="driver",
		                  help=_(u"Install the driver"))
		parser.add_option("-g", "--gtk",action="store_true",
		                  help=_(u"Launch Easycam with gtk interface"),default=False)
		parser.add_option("-q", "--qt",action="store_true",
		                  help=_(u"Launch Easycam with qt interface"),default=False)
		parser.add_option("-d", "--id2driver",dest="id",
		                  help=_(u"Find the driver corresponding to the id"))
		parser.add_option("-n", "--name2id",dest="name",
		                  help=_(u"Find the id corresponding to the name"))
		(options, args) = parser.parse_args()
		
		if options.gtk:
			os.system('gksudo python /usr/share/EasyCam2/gtk/gui-gtk.py')
		if options.qt:
			os.system('kdesudo python /usr/share/EasyCam2/qt/gui-qt.py')
		if options.driver:
			self.installation(options.driver)	
		
		if options.id:
			self.id2driver(options.id)
		if options.name:
			self.name2id(options.name)
	def installation (self,driver):
		version_kernel = os.popen('uname -r').readline()[0:6]
        	if driver == "spca" :
			if version_kernel < '2.6.11' :
				pass
			else :
				driver = 'gspca'
		version =  commands.getoutput("uname -r")
		dir = '/usr/share/EasyCam2/drivers/%s' % driver
		try:
			os.chdir(dir)
		except:
			print "Ce driver n'est pas compatible avec Easycam, ou l'orthographe est incorrecte ... ou il n'existe pas :)"
			sys.exit()
		os.system("sudo ln -s /lib/modules/%s/build/include/linux/autoconf.h" % version + " /lib/modules/%s/build/include/linux/config.h" % version)
		os.system("sudo apt-get install --assume-yes linux-headers-`uname -r`")
		fichier_installation = open('/usr/share/EasyCam2/install/%s' % driver,'r')
		lignes  = fichier_installation.readlines()
		for instruction in lignes :
			try :	
				os.system(instruction)	
			except:
				return instruction
	     	fichier_installation.close()

	def id2driver (self,id):
		global cf
		a = 0
		info = cf.getDriverListByID(id)[0]
		driver=[]
		while a < len(info):
			driver.append(cf.getDriverInfo(info[a])['name'])
			a = a+1
		if driver == [] :
			print _( u"Votre webcam n'est pas compatible avec Easycam .... Pour le moment.\nN'hésitez pas à réclamer l'intégration de votre webcam sur le site d'Easycam : http://blognux.free.fr")	
			return False	
		else :
			print driver
			return driver

	def name2id (self,name):
		global cf
		id = cf.getIDByName(name)
		if id :
			print id
			return id
		else : 
			print _( u"Ce nom de webcam n'est pas dans la base de donnée d'Easycam")
			return False
if __name__ == '__main__':
	error = 0	
	try:
	        cf = easycamconfig.ConfigInfo()
	except IOError:
	        # config file is missing
	        print _( u"Le fichier de configuration n'a pas été détecter!\nReinstallez easycam")
	        error = 1
	except xml.parsers.expat.ExpatError:
	       	# error in XML syntax
	       	print _( u"Le fichier de configuration est défectueux.\nReinstallez easycam")      	
		error = 1
	if error == 0:	
		Main()
