/** 
 * @file gl860-dev-0503.c
 * @author Olivier LORIN, tiré des logs de Malmostoso et du pilote Syntek par Nicolas VIVIEN
 * @date 2008-05-05
 * @version v0.9.0
 *
 * @brief Driver for GL860 USB video camera
 *
 * @note Copyright (C) Olivier LORIN
 *
 * @par Licences
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#include <linux/module.h>
#include <linux/init.h>
#include <linux/kernel.h>
#include <linux/version.h>
#include <linux/errno.h>
#include <linux/slab.h>
#include <linux/kref.h>

#include <linux/usb.h>
#include <media/v4l2-common.h>

#include "gl860.h"
#include "gl860-dev.h"

#define ctrl_in fct_RTx
#define ctrl_out fct_RTx

// Code issu de logs de Malmostoso
// Capteur : OV2640

static int excj   = -1;
static int exnet  = -1;
static int exsat  = -1;
static int excoul = -1;
static int exsrc  = -1;
static int excntr = -1;
static int exgam  = -1;
static int exlum  = -1;

char msi005[]={ 0xff }; // ATTENDU
char msi006[]={ 0xff }; // ATTENDU
char msi007[]={ 0xff }; // ATTENDU
char msi008[]={ 0xff }; // ATTENDU
char msi009[]={ 0x26 }; // ATTENDU
char msi010[]={ 0x63 }; // ATTENDU
char msi011[]={ 0x50 }; // ATTENDU
char msi012[]={ 0x75 }; // ATTENDU
char msi013[]={ 0xde }; // ATTENDU
char msi014[]={ 0x75 }; // ATTENDU
char msi015[]={ 0xd8 }; // ATTENDU
char msi016[]={ 0x77 }; // ATTENDU
char msi017[]={ 0xd2 }; // ATTENDU
char msi018[]={ 0x75 }; // ATTENDU
char msi019[]={ 0x56 }; // ATTENDU
char msi020[]={ 0x77 }; // ATTENDU
char msi021[]={ 0x5c }; // ATTENDU
char msi022[]={ 0x75 }; // ATTENDU
char msi023[]={ 0xd8 }; // ATTENDU
char msi024[]={ 0x77 }; // ATTENDU
char msi025[]={ 0xd2 }; // ATTENDU
char msi026[]={ 0x75 }; // ATTENDU
char msi027[]={ 0x56 }; // ATTENDU
char msi028[]={ 0x75 }; // ATTENDU
char msi029[]={ 0x5c }; // ATTENDU
char msi030[]={ 0x77 }; // ATTENDU
char msi031[]={ 0xd8 }; // ATTENDU
char msi032[]={ 0x75 }; // ATTENDU
char msi033[]={ 0xd2 }; // ATTENDU
char msi034[]={ 0x77 }; // ATTENDU
char msi035[]={ 0x56 }; // ATTENDU
char msi036[]={ 0x77 }; // ATTENDU
char msi037[]={ 0x5c }; // ATTENDU
char msi038[]={ 0x75 }; // ATTENDU
char msi039[]={ 0xd8 }; // ATTENDU
char msi040[]={ 0x77 }; // ATTENDU
char msi041[]={ 0xd2 }; // ATTENDU
char msi042[]={ 0x77 }; // ATTENDU
char msi043[]={ 0x56 }; // ATTENDU
char msi044[]={ 0x75 }; // ATTENDU
char msi045[]={ 0x5c }; // ATTENDU
char msi046[]={ 0x77 }; // ATTENDU
char msi047[]={ 0xd8 }; // ATTENDU
char msi048[]={ 0x77 }; // ATTENDU
char msi049[]={ 0xd2 }; // ATTENDU
char msi050[]={ 0x75 }; // ATTENDU
char msi051[]={ 0x56 }; // ATTENDU
char msi052[]={ 0x77 }; // ATTENDU
char msi053[]={ 0x5c }; // ATTENDU
char msi054[]={ 0x77 }; // ATTENDU
char msi055[]={ 0xd8 }; // ATTENDU
char msi056[]={ 0x75 }; // ATTENDU
char msi057[]={ 0xd2 }; // ATTENDU
char msi058[]={ 0x77 }; // ATTENDU
char msi059[]={ 0x56 }; // ATTENDU
char msi060[]={ 0x77 }; // ATTENDU
char msi061[]={ 0x5c }; // ATTENDU
char msi062[]={ 0x75 }; // ATTENDU
char msi063[]={ 0xd8 }; // ATTENDU
char msi064[]={ 0x77 }; // ATTENDU
char msi065[]={ 0xd2 }; // ATTENDU
char msi066[]={ 0x75 }; // ATTENDU
char msi067[]={ 0x56 }; // ATTENDU
char msi068[]={ 0x77 }; // ATTENDU
char msi069[]={ 0x5c }; // ATTENDU
char msi070[]={ 0x77 }; // ATTENDU
char msi071[]={ 0xd8 }; // ATTENDU
char msi072[]={ 0x75 }; // ATTENDU
char msi073[]={ 0xd2 }; // ATTENDU
char msi074[]={ 0x77 }; // ATTENDU
char msi075[]={ 0x56 }; // ATTENDU
char msi076[]={ 0x77 }; // ATTENDU
char msi077[]={ 0x5c }; // ATTENDU
char msi078[]={ 0x75 }; // ATTENDU
char msi079[]={ 0xd8 }; // ATTENDU
char msi080[]={ 0x77 }; // ATTENDU
char msi081[]={ 0xd2 }; // ATTENDU
char msi082[]={ 0x77 }; // ATTENDU
char msi083[]={ 0x56 }; // ATTENDU
char msi084[]={ 0x75 }; // ATTENDU
char msi085[]={ 0x5c }; // ATTENDU
char msi086[]={ 0x77 }; // ATTENDU
char msi087[]={ 0xd8 }; // ATTENDU
char msi088[]={ 0x77 }; // ATTENDU
char msi089[]={ 0xd2 }; // ATTENDU
char msi090[]={ 0x75 }; // ATTENDU
char msi091[]={ 0x56 }; // ATTENDU
char msi092[]={ 0x77 }; // ATTENDU
char msi093[]={ 0x5c }; // ATTENDU
char msi094[]={ 0x77 }; // ATTENDU
char msi095[]={ 0xd8 }; // ATTENDU
char msi096[]={ 0x75 }; // ATTENDU
char msi097[]={ 0xd2 }; // ATTENDU
char msi098[]={ 0x77 }; // ATTENDU
char msi099[]={ 0x56 }; // ATTENDU
char msi100[]={ 0x77 }; // ATTENDU
char msi101[]={ 0x5c }; // ATTENDU
char msi102[]={ 0x75 }; // ATTENDU
char msi103[]={ 0xd8 }; // ATTENDU
char msi104[]={ 0x75 }; // ATTENDU
char msi105[]={ 0xd2 }; // ATTENDU
char msi106[]={ 0x75 }; // ATTENDU
char msi107[]={ 0x56 }; // ATTENDU
char msi108[]={ 0x75 }; // ATTENDU
char msi109[]={ 0x5c }; // ATTENDU
char msi110[]={ 0x77 }; // ATTENDU
char msi111[]={ 0xd8 }; // ATTENDU
char msi112[]={ 0x77 }; // ATTENDU
char msi113[]={ 0xd2 }; // ATTENDU
char msi114[]={ 0x77 }; // ATTENDU
char msi115[]={ 0x56 }; // ATTENDU
char msi116[]={ 0x75 }; // ATTENDU
char msi117[]={ 0x5c }; // ATTENDU
char msi118[]={ 0x75 }; // ATTENDU
char msi119[]={ 0xd8 }; // ATTENDU
char msi120[]={ 0x77 }; // ATTENDU
char msi121[]={ 0xd2 }; // ATTENDU
char msi122[]={ 0x77 }; // ATTENDU
char msi123[]={ 0x56 }; // ATTENDU
char msi124[]={ 0x77 }; // ATTENDU
char msi125[]={ 0x5c }; // ATTENDU
char msi126[]={ 0x77 }; // ATTENDU
char msi127[]={ 0xd8 }; // ATTENDU
char msi128[]={ 0x77 }; // ATTENDU
char msi129[]={ 0xd2 }; // ATTENDU
char msi130[]={ 0x77 }; // ATTENDU
char msi131[]={ 0x56 }; // ATTENDU
char msi132[]={ 0x77 }; // ATTENDU
char msi133[]={ 0x5c }; // ATTENDU
char msi134[]={ 0x77 }; // ATTENDU
char msi135[]={ 0xd8 }; // ATTENDU
char msi136[]={ 0x77 }; // ATTENDU
char msi137[]={ 0xd2 }; // ATTENDU
char msi138[]={ 0x77 }; // ATTENDU
char msi139[]={ 0x56 }; // ATTENDU
char msi140[]={ 0x77 }; // ATTENDU
char msi141[]={ 0x5c }; // ATTENDU
char msi142[]={ 0x77 }; // ATTENDU
char msi143[]={ 0xd8 }; // ATTENDU
char msi144[]={ 0x77 }; // ATTENDU
char msi145[]={ 0xd2 }; // ATTENDU
char msi146[]={ 0x77 }; // ATTENDU
char msi147[]={ 0x56 }; // ATTENDU
char msi148[]={ 0x75 }; // ATTENDU
char msi149[]={ 0x5c }; // ATTENDU
char msi150[]={ 0x77 }; // ATTENDU
char msi151[]={ 0xd8 }; // ATTENDU
char msi152[]={ 0x75 }; // ATTENDU
char msi153[]={ 0xd2 }; // ATTENDU
char msi154[]={ 0x77 }; // ATTENDU
char msi155[]={ 0x56 }; // ATTENDU
char msi156[]={ 0x77 }; // ATTENDU
char msi157[]={ 0x5c }; // ATTENDU
char msi158[]={ 0x77 }; // ATTENDU
char msi159[]={ 0xd8 }; // ATTENDU
char msi160[]={ 0x77 }; // ATTENDU
char msi161[]={ 0xd2 }; // ATTENDU
char msi162[]={ 0x77 }; // ATTENDU
char msi163[]={ 0x56 }; // ATTENDU
char msi164[]={ 0x77 }; // ATTENDU
char msi165[]={ 0x5c }; // ATTENDU
char msi166[]={ 0x77 }; // ATTENDU
char msi167[]={ 0xd8 }; // ATTENDU
char msi168[]={ 0x77 }; // ATTENDU
char msi169[]={ 0xd2 }; // ATTENDU
char msi170[]={ 0x77 }; // ATTENDU
char msi171[]={ 0x56 }; // ATTENDU
char msi172[]={ 0x75 }; // ATTENDU
char msi173[]={ 0x5c }; // ATTENDU
char msi174[]={ 0x77 }; // ATTENDU
char msi175[]={ 0xd8 }; // ATTENDU
char msi176[]={ 0x75 }; // ATTENDU
char msi177[]={ 0xd2 }; // ATTENDU
char msi178[]={ 0x75 }; // ATTENDU
char msi179[]={ 0x56 }; // ATTENDU
char msi180[]={ 0x77 }; // ATTENDU
char msi181[]={ 0x5c }; // ATTENDU
char msi182[]={ 0x75 }; // ATTENDU
char msi183[]={ 0xd8 }; // ATTENDU
char msi184[]={ 0x77 }; // ATTENDU
char msi185[]={ 0xd2 }; // ATTENDU
char msi186[]={ 0x75 }; // ATTENDU
char msi187[]={ 0x56 }; // ATTENDU
char msi188[]={ 0x77 }; // ATTENDU
char msi189[]={ 0x5c }; // ATTENDU
char msi190[]={ 0x77 }; // ATTENDU
char msi191[]={ 0xd8 }; // ATTENDU
char msi192[]={ 0x75 }; // ATTENDU
char msi193[]={ 0xd2 }; // ATTENDU
char msi194[]={ 0x75 }; // ATTENDU
char msi195[]={ 0x56 }; // ATTENDU
char msi196[]={ 0x75 }; // ATTENDU
char msi197[]={ 0x5c }; // ATTENDU
char msi198[]={ 0x77 }; // ATTENDU
char msi199[]={ 0xd8 }; // ATTENDU
char msi200[]={ 0x77 }; // ATTENDU
char msi201[]={ 0xd2 }; // ATTENDU
char msi202[]={ 0x75 }; // ATTENDU
char msi203[]={ 0x56 }; // ATTENDU
char msi204[]={ 0x75 }; // ATTENDU
char msi205[]={ 0x5c }; // ATTENDU
char msi206[]={ 0x76 }; // ATTENDU
char msi207[]={ 0xd8 }; // ATTENDU
char msi208[]={ 0x5c }; // ATTENDU
char msi209[]={ 0x56 }; // ATTENDU
char msi210[]={ 0xd2 }; // ATTENDU
char msi211[]={ 0xd8 }; // ATTENDU
char msi212[]={ 0x5c }; // ATTENDU
char msi213[]={ 0x56 }; // ATTENDU
char msi214[]={ 0xd2 }; // ATTENDU
char msi215[]={ 0xd8 }; // ATTENDU
char msi216[]={ 0x5c }; // ATTENDU
char msi217[]={ 0x56 }; // ATTENDU
char msi218[]={ 0xd2 }; // ATTENDU
char msi219[]={ 0xd8 }; // ATTENDU
char msi220[]={ 0x5c }; // ATTENDU
char msi221[]={ 0x56 }; // ATTENDU
char msi222[]={ 0xd2 }; // ATTENDU
char msi223[]={ 0xd8 }; // ATTENDU
char msi224[]={ 0x5c }; // ATTENDU
char msi225[]={ 0x56 }; // ATTENDU
char msi226[]={ 0xd2 }; // ATTENDU
char msi227[]={ 0xd8 }; // ATTENDU
char msi228[]={ 0x5c }; // ATTENDU
char msi229[]={ 0x56 }; // ATTENDU
char msi230[]={ 0xd2 }; // ATTENDU
char msi231[]={ 0xd8 }; // ATTENDU
char msi232[]={ 0x5c }; // ATTENDU
char msi233[]={ 0x56 }; // ATTENDU
char msi234[]={ 0xd2 }; // ATTENDU
char msi235[]={ 0xd8 }; // ATTENDU
char msi236[]={ 0x5c }; // ATTENDU
char msi237[]={ 0x56 }; // ATTENDU
char msi238[]={ 0xd2 }; // ATTENDU
char msi239[]={ 0xd8 }; // ATTENDU
char msi240[]={ 0x5c }; // ATTENDU
char msi241[]={ 0x56 }; // ATTENDU
char msi242[]={ 0xd2 }; // ATTENDU
char msi243[]={ 0xd8 }; // ATTENDU
char msi244[]={ 0x5c }; // ATTENDU
char msi245[]={ 0x56 }; // ATTENDU
char msi246[]={ 0xd2 }; // ATTENDU
char msi247[]={ 0xd8 }; // ATTENDU
char msi248[]={ 0x5c }; // ATTENDU
char msi249[]={ 0x56 }; // ATTENDU
char msi250[]={ 0xd2 }; // ATTENDU
char msi251[]={ 0xd8 }; // ATTENDU
char msi252[]={ 0x5c }; // ATTENDU
char msi253[]={ 0x56 }; // ATTENDU
char msi254[]={ 0xd2 }; // ATTENDU
char msi255[]={ 0xd8 }; // ATTENDU
char msi256[]={ 0x5c }; // ATTENDU
char msi257[]={ 0x56 }; // ATTENDU
char msi258[]={ 0xd2 }; // ATTENDU
char msi259[]={ 0xd8 }; // ATTENDU
char msi260[]={ 0x5c }; // ATTENDU
char msi261[]={ 0x56 }; // ATTENDU
char msi262[]={ 0xd2 }; // ATTENDU
char msi263[]={ 0xd8 }; // ATTENDU
char msi264[]={ 0x5c }; // ATTENDU
char msi265[]={ 0x56 }; // ATTENDU
char msi266[]={ 0xd2 }; // ATTENDU
char msi267[]={ 0xd8 }; // ATTENDU
char msi268[]={ 0x5c }; // ATTENDU
char msi269[]={ 0x56 }; // ATTENDU
char msi270[]={ 0xd2 }; // ATTENDU
char msi271[]={ 0xd8 }; // ATTENDU
char msi272[]={ 0x5c }; // ATTENDU
char msi273[]={ 0x56 }; // ATTENDU
char msi274[]={ 0xd2 }; // ATTENDU
char msi275[]={ 0xd8 }; // ATTENDU
char msi276[]={ 0x5c }; // ATTENDU
char msi277[]={ 0x56 }; // ATTENDU
char msi278[]={ 0xd2 }; // ATTENDU
char msi279[]={ 0xd8 }; // ATTENDU
char msi280[]={ 0x5c }; // ATTENDU
char msi281[]={ 0x56 }; // ATTENDU
char msi282[]={ 0xd2 }; // ATTENDU
char msi283[]={ 0xd8 }; // ATTENDU
char msi284[]={ 0x5c }; // ATTENDU
char msi285[]={ 0x56 }; // ATTENDU
char msi286[]={ 0xd2 }; // ATTENDU
char msi287[]={ 0xd8 }; // ATTENDU
char msi288[]={ 0x5c }; // ATTENDU
char msi289[]={ 0x56 }; // ATTENDU
char msi290[]={ 0xd2 }; // ATTENDU
char msi291[]={ 0xd8 }; // ATTENDU
char msi292[]={ 0x5c }; // ATTENDU
char msi293[]={ 0x56 }; // ATTENDU
char msi294[]={ 0xd2 }; // ATTENDU
char msi295[]={ 0xd8 }; // ATTENDU
char msi296[]={ 0x5c }; // ATTENDU
char msi297[]={ 0x56 }; // ATTENDU
char msi298[]={ 0xd2 }; // ATTENDU
char msi299[]={ 0xd8 }; // ATTENDU
char msi300[]={ 0x5c }; // ATTENDU
char msi301[]={ 0x56 }; // ATTENDU
char msi302[]={ 0xd2 }; // ATTENDU
char msi303[]={ 0xd8 }; // ATTENDU
char msi304[]={ 0x5c }; // ATTENDU
char msi305[]={ 0x56 }; // ATTENDU
char msi306[]={ 0xd2 }; // ATTENDU
char msi307[]={ 0xd8 }; // ATTENDU
char msi308[]={ 0x5c }; // ATTENDU
char msi309[]={ 0x56 }; // ATTENDU
char msi310[]={ 0xd2 }; // ATTENDU
char msi311[]={ 0x75 }; // ATTENDU
char msi312[]={ 0xd8 }; // ATTENDU
char msi313[]={ 0xd2 }; // ATTENDU
char msi314[]={ 0x56 }; // ATTENDU
char msi315[]={ 0x5c }; // ATTENDU
char msi316[]={ 0xd8 }; // ATTENDU
char msi317[]={ 0xd2 }; // ATTENDU
char msi318[]={ 0x56 }; // ATTENDU
char msi319[]={ 0x5c }; // ATTENDU
char msi320[]={ 0xd8 }; // ATTENDU
char msi321[]={ 0x00, 0x41, 0x07, 0x6a, 0x06, 0x61, 0x0d, 0x6a, 0x10, 0x10, 0xc1, 0x01 };
char msi322[]={ 0x61 }; // ATTENDU
char msi323[]={ 0x51 }; // ATTENDU

/*
char msc000[]={ 0x00, 0x41, 0x07, 0x6a, 0x06, 0x61, 0x0d, 0x6a, 0x10, 0x10, 0xc1, 0x01 };
char msc001[]={ 0x61 }; // ATTENDU
char msc002[]={ 0x51 }; // ATTENDU
char msc003[]={ 0x51 }; // ATTENDU
char msc004[]={ 0xd0, 0x01, 0xd1, 0x08, 0xd2, 0xe0, 0xd3, 0x02, 0xd4, 0x10, 0xd5, 0x81 };
char msc006[]={ 0x28 }; // ATTENDU
char msc007[]={ 0xa8 }; // ATTENDU
*/
//char msc008[]={ 0x50 }; // ATTENDU

char mscommun[]={ 0x00, 0x41, 0x07, 0x6a, 0x06, 0xef, 0x0d, 0x6a, 0x10, 0x10, 0xc1, 0x01 };
char ms640[] ={ 0xd0, 0x01, 0xd1, 0x08, 0xd2, 0xe0, 0xd3, 0x02, 0xd4, 0x10, 0xd5, 0x81 };
char ms800[] ={ 0xd0, 0x01, 0xd1, 0x10, 0xd2, 0x58, 0xd3, 0x02, 0xd4, 0x18, 0xd5, 0x21 };
char ms1280[]={ 0xd0, 0x01, 0xd1, 0x18, 0xd2, 0xc0, 0xd3, 0x02, 0xd4, 0x28, 0xd5, 0x01 };
char ms1600[]={ 0xd0, 0x01, 0xd1, 0x20, 0xd2, 0xb0, 0xd3, 0x02, 0xd4, 0x30, 0xd5, 0x41 };

char ms50[]={ 0x50 }; // ATTENDU
char ms28[]={ 0x28 }; // ATTENDU
char msa8[]={ 0xa8 }; // ATTENDU

//=============================================================================
//
// STK-M811 API / STK-A311 API
//
//=============================================================================

/** 
 * @param dev Device structure
 * 
 * @returns 0 if all is OK
 *
 * @brief This function permits to initialize the device.
 *
 * This function must be called at first. It's the start of the
 * initialization process. After this process, the device is
 * completly initalized and it's ready.
 *
 * This function is written from the USB log.
 */
int dev_0503ms_initialize_device(struct usb_gl860 *dev)
{
	STK_DEBUG("dev_0503ms_initialize_device [ini]\n");


	ctrl_out(dev, 0x40, 1, 0x0000, 0x0000, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x0010, 0x0010, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x0008, 0x00c0, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x0001, 0x00c1, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x0001, 0x00c2, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x0020, 0x0006, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x006a, 0x000d, 0, NULL);
/*
	ctrl_out(dev, 0x40, 1, 0x0040, 0x0000, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x0063, 0x0006, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x7a00, 0x8030, 0, NULL);
	ctrl_in(dev, 0xc0, 2, 0x7a00, 0x8030, 1, (void*)msi005);
	STK_INFO("probe=%2x\n",(*msi005)&0xFF);

	ctrl_out(dev, 0x40, 1, 0x0040, 0x0000, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x0063, 0x0006, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x7a00, 0x8030, 0, NULL);
	ctrl_in(dev, 0xc0, 2, 0x7a00, 0x8030, 1, (void*)msi006);

	ctrl_out(dev, 0x40, 1, 0x0040, 0x0000, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x0063, 0x0006, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x7a00, 0x8030, 0, NULL);
	ctrl_in(dev, 0xc0, 2, 0x7a00, 0x8030, 1, (void*)msi007);

	ctrl_out(dev, 0x40, 1, 0x0040, 0x0000, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x0063, 0x0006, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x7a00, 0x8030, 0, NULL);
	ctrl_in(dev, 0xc0, 2, 0x7a00, 0x8030, 1, (void*)msi008);
*/
	ctrl_out(dev, 0x40, 1, 0x0040, 0x0000, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x800a, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x6000, 0x800a, 1, (void*)msi009);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0006, 1, (void*)msi010);

	ctrl_out(dev, 0x40, 1, 0x00ef, 0x0006, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi011);

	ctrl_out(dev, 0x40, 1, 0x00de, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi012);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi013);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi014);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi015);

	ctrl_out(dev, 0x40, 1, 0x00d2, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi016);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi017);

	ctrl_out(dev, 0x40, 1, 0x0056, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi018);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi019);

	ctrl_out(dev, 0x40, 1, 0x005c, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi020);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi021);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi022);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi023);

	ctrl_out(dev, 0x40, 1, 0x00d2, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi024);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi025);

	ctrl_out(dev, 0x40, 1, 0x0056, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi026);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi027);

	ctrl_out(dev, 0x40, 1, 0x005c, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi028);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi029);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi030);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi031);

	ctrl_out(dev, 0x40, 1, 0x00d2, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi032);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi033);

	ctrl_out(dev, 0x40, 1, 0x0056, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi034);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi035);

	ctrl_out(dev, 0x40, 1, 0x005c, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi036);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi037);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi038);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi039);

	ctrl_out(dev, 0x40, 1, 0x00d2, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi040);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi041);

	ctrl_out(dev, 0x40, 1, 0x0056, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi042);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi043);

	ctrl_out(dev, 0x40, 1, 0x005c, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi044);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi045);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi046);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi047);

	ctrl_out(dev, 0x40, 1, 0x00d2, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi048);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi049);

	ctrl_out(dev, 0x40, 1, 0x0056, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi050);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi051);

	ctrl_out(dev, 0x40, 1, 0x005c, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi052);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi053);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi054);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi055);

	ctrl_out(dev, 0x40, 1, 0x00d2, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi056);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi057);

	ctrl_out(dev, 0x40, 1, 0x0056, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi058);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi059);

	ctrl_out(dev, 0x40, 1, 0x005c, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi060);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi061);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi062);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi063);

	ctrl_out(dev, 0x40, 1, 0x00d2, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi064);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi065);

	ctrl_out(dev, 0x40, 1, 0x0056, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi066);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi067);

	ctrl_out(dev, 0x40, 1, 0x005c, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi068);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi069);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi070);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi071);

	ctrl_out(dev, 0x40, 1, 0x00d2, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi072);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi073);

	ctrl_out(dev, 0x40, 1, 0x0056, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi074);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi075);

	ctrl_out(dev, 0x40, 1, 0x005c, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi076);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi077);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi078);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi079);

	ctrl_out(dev, 0x40, 1, 0x00d2, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi080);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi081);

	ctrl_out(dev, 0x40, 1, 0x0056, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi082);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi083);

	ctrl_out(dev, 0x40, 1, 0x005c, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi084);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi085);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi086);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi087);

	ctrl_out(dev, 0x40, 1, 0x00d2, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi088);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi089);

	ctrl_out(dev, 0x40, 1, 0x0056, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi090);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi091);

	ctrl_out(dev, 0x40, 1, 0x005c, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi092);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi093);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi094);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi095);

	ctrl_out(dev, 0x40, 1, 0x00d2, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi096);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi097);

	ctrl_out(dev, 0x40, 1, 0x0056, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi098);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi099);

	ctrl_out(dev, 0x40, 1, 0x005c, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi100);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi101);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi102);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi103);

	ctrl_out(dev, 0x40, 1, 0x00d2, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi104);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi105);

	ctrl_out(dev, 0x40, 1, 0x0056, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi106);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi107);

	ctrl_out(dev, 0x40, 1, 0x005c, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi108);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi109);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi110);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi111);

	ctrl_out(dev, 0x40, 1, 0x00d2, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi112);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi113);

	ctrl_out(dev, 0x40, 1, 0x0056, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi114);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi115);

	ctrl_out(dev, 0x40, 1, 0x005c, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi116);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi117);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi118);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi119);

	ctrl_out(dev, 0x40, 1, 0x00d2, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi120);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi121);

	ctrl_out(dev, 0x40, 1, 0x0056, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi122);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi123);

	ctrl_out(dev, 0x40, 1, 0x005c, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi124);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi125);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi126);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi127);

	ctrl_out(dev, 0x40, 1, 0x00d2, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi128);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi129);

	ctrl_out(dev, 0x40, 1, 0x0056, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi130);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi131);

	ctrl_out(dev, 0x40, 1, 0x005c, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi132);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi133);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi134);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi135);

	ctrl_out(dev, 0x40, 1, 0x00d2, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi136);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi137);

	ctrl_out(dev, 0x40, 1, 0x0056, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi138);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi139);

	ctrl_out(dev, 0x40, 1, 0x005c, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi140);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi141);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi142);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi143);

	ctrl_out(dev, 0x40, 1, 0x00d2, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi144);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi145);

	ctrl_out(dev, 0x40, 1, 0x0056, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi146);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi147);

	ctrl_out(dev, 0x40, 1, 0x005c, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi148);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi149);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi150);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi151);

	ctrl_out(dev, 0x40, 1, 0x00d2, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi152);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi153);

	ctrl_out(dev, 0x40, 1, 0x0056, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi154);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi155);

	ctrl_out(dev, 0x40, 1, 0x005c, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi156);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi157);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi158);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi159);

	ctrl_out(dev, 0x40, 1, 0x00d2, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi160);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi161);

	ctrl_out(dev, 0x40, 1, 0x0056, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi162);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi163);

	ctrl_out(dev, 0x40, 1, 0x005c, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi164);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi165);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi166);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi167);

	ctrl_out(dev, 0x40, 1, 0x00d2, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi168);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi169);

	ctrl_out(dev, 0x40, 1, 0x0056, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi170);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi171);

	ctrl_out(dev, 0x40, 1, 0x005c, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi172);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi173);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi174);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi175);

	ctrl_out(dev, 0x40, 1, 0x00d2, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi176);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi177);

	ctrl_out(dev, 0x40, 1, 0x0056, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi178);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi179);

	ctrl_out(dev, 0x40, 1, 0x005c, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi180);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi181);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi182);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi183);

	ctrl_out(dev, 0x40, 1, 0x00d2, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi184);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi185);

	ctrl_out(dev, 0x40, 1, 0x0056, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi186);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi187);

	ctrl_out(dev, 0x40, 1, 0x005c, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi188);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi189);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi190);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi191);

	ctrl_out(dev, 0x40, 1, 0x00d2, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi192);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi193);

	ctrl_out(dev, 0x40, 1, 0x0056, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi194);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi195);

	ctrl_out(dev, 0x40, 1, 0x005c, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi196);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi197);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi198);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi199);

	ctrl_out(dev, 0x40, 1, 0x00d2, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi200);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi201);

	ctrl_out(dev, 0x40, 1, 0x0056, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi202);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi203);

	ctrl_out(dev, 0x40, 1, 0x005c, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi204);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi205);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi206);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi207);

	ctrl_out(dev, 0x40, 1, 0x005c, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi208);

	ctrl_out(dev, 0x40, 1, 0x0056, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi209);

	ctrl_out(dev, 0x40, 1, 0x00d2, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi210);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi211);

	ctrl_out(dev, 0x40, 1, 0x005c, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi212);

	ctrl_out(dev, 0x40, 1, 0x0056, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi213);

	ctrl_out(dev, 0x40, 1, 0x00d2, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi214);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi215);

	ctrl_out(dev, 0x40, 1, 0x005c, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi216);

	ctrl_out(dev, 0x40, 1, 0x0056, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi217);

	ctrl_out(dev, 0x40, 1, 0x00d2, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi218);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi219);

	ctrl_out(dev, 0x40, 1, 0x005c, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi220);

	ctrl_out(dev, 0x40, 1, 0x0056, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi221);

	ctrl_out(dev, 0x40, 1, 0x00d2, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi222);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi223);

	ctrl_out(dev, 0x40, 1, 0x005c, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi224);

	ctrl_out(dev, 0x40, 1, 0x0056, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi225);

	ctrl_out(dev, 0x40, 1, 0x00d2, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi226);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi227);

	ctrl_out(dev, 0x40, 1, 0x005c, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi228);

	ctrl_out(dev, 0x40, 1, 0x0056, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi229);

	ctrl_out(dev, 0x40, 1, 0x00d2, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi230);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi231);

	ctrl_out(dev, 0x40, 1, 0x005c, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi232);

	ctrl_out(dev, 0x40, 1, 0x0056, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi233);

	ctrl_out(dev, 0x40, 1, 0x00d2, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi234);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi235);

	ctrl_out(dev, 0x40, 1, 0x005c, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi236);

	ctrl_out(dev, 0x40, 1, 0x0056, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi237);

	ctrl_out(dev, 0x40, 1, 0x00d2, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi238);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi239);

	ctrl_out(dev, 0x40, 1, 0x005c, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi240);

	ctrl_out(dev, 0x40, 1, 0x0056, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi241);

	ctrl_out(dev, 0x40, 1, 0x00d2, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi242);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi243);

	ctrl_out(dev, 0x40, 1, 0x005c, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi244);

	ctrl_out(dev, 0x40, 1, 0x0056, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi245);

	ctrl_out(dev, 0x40, 1, 0x00d2, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi246);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi247);

	ctrl_out(dev, 0x40, 1, 0x005c, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi248);

	ctrl_out(dev, 0x40, 1, 0x0056, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi249);

	ctrl_out(dev, 0x40, 1, 0x00d2, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi250);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi251);

	ctrl_out(dev, 0x40, 1, 0x005c, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi252);

	ctrl_out(dev, 0x40, 1, 0x0056, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi253);

	ctrl_out(dev, 0x40, 1, 0x00d2, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi254);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi255);

	ctrl_out(dev, 0x40, 1, 0x005c, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi256);

	ctrl_out(dev, 0x40, 1, 0x0056, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi257);

	ctrl_out(dev, 0x40, 1, 0x00d2, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi258);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi259);

	ctrl_out(dev, 0x40, 1, 0x005c, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi260);

	ctrl_out(dev, 0x40, 1, 0x0056, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi261);

	ctrl_out(dev, 0x40, 1, 0x00d2, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi262);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi263);

	ctrl_out(dev, 0x40, 1, 0x005c, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi264);

	ctrl_out(dev, 0x40, 1, 0x0056, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi265);

	ctrl_out(dev, 0x40, 1, 0x00d2, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi266);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi267);

	ctrl_out(dev, 0x40, 1, 0x005c, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi268);

	ctrl_out(dev, 0x40, 1, 0x0056, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi269);

	ctrl_out(dev, 0x40, 1, 0x00d2, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi270);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi271);

	ctrl_out(dev, 0x40, 1, 0x005c, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi272);

	ctrl_out(dev, 0x40, 1, 0x0056, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi273);

	ctrl_out(dev, 0x40, 1, 0x00d2, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi274);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi275);

	ctrl_out(dev, 0x40, 1, 0x005c, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi276);

	ctrl_out(dev, 0x40, 1, 0x0056, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi277);

	ctrl_out(dev, 0x40, 1, 0x00d2, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi278);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi279);

	ctrl_out(dev, 0x40, 1, 0x005c, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi280);

	ctrl_out(dev, 0x40, 1, 0x0056, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi281);

	ctrl_out(dev, 0x40, 1, 0x00d2, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi282);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi283);

	ctrl_out(dev, 0x40, 1, 0x005c, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi284);

	ctrl_out(dev, 0x40, 1, 0x0056, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi285);

	ctrl_out(dev, 0x40, 1, 0x00d2, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi286);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi287);

	ctrl_out(dev, 0x40, 1, 0x005c, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi288);

	ctrl_out(dev, 0x40, 1, 0x0056, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi289);

	ctrl_out(dev, 0x40, 1, 0x00d2, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi290);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi291);

	ctrl_out(dev, 0x40, 1, 0x005c, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi292);

	ctrl_out(dev, 0x40, 1, 0x0056, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi293);

	ctrl_out(dev, 0x40, 1, 0x00d2, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi294);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi295);

	ctrl_out(dev, 0x40, 1, 0x005c, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi296);

	ctrl_out(dev, 0x40, 1, 0x0056, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi297);

	ctrl_out(dev, 0x40, 1, 0x00d2, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi298);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi299);

	ctrl_out(dev, 0x40, 1, 0x005c, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi300);

	ctrl_out(dev, 0x40, 1, 0x0056, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi301);

	ctrl_out(dev, 0x40, 1, 0x00d2, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi302);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi303);

	ctrl_out(dev, 0x40, 1, 0x005c, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi304);

	ctrl_out(dev, 0x40, 1, 0x0056, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi305);

	ctrl_out(dev, 0x40, 1, 0x00d2, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi306);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi307);

	ctrl_out(dev, 0x40, 1, 0x005c, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi308);

	ctrl_out(dev, 0x40, 1, 0x0056, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi309);

	ctrl_out(dev, 0x40, 1, 0x00d2, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi310);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0007, 1, (void*)msi311);
	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi312);

	ctrl_out(dev, 0x40, 1, 0x00d2, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi313);

	ctrl_out(dev, 0x40, 1, 0x0056, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi314);

	ctrl_out(dev, 0x40, 1, 0x005c, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi315);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi316);

	ctrl_out(dev, 0x40, 1, 0x00d2, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi317);

	ctrl_out(dev, 0x40, 1, 0x0056, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi318);

	ctrl_out(dev, 0x40, 1, 0x005c, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi319);

	ctrl_out(dev, 0x40, 1, 0x00d8, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi320);

	ctrl_out(dev, 0x40, 1, 0x0050, 0x0000, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x0041, 0x0000, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x006a, 0x0007, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x0061, 0x0006, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x006a, 0x000d, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x0000, 0x00c0, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x0010, 0x0010, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x0001, 0x00c1, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x0041, 0x00c2, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x0004, 0x00d8, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x0012, 0x0004, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x0000, 0x0058, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x0041, 0x0000, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x0061, 0x0000, 0, NULL);
	ctrl_out(dev, 0x40, 3, 0x0000, 0x0200, 12, (void*)msi321);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x00ff, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60ff, 0x002c, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60df, 0x002e, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6001, 0x00ff, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6080, 0x0012, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0000, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0045, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0010, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6035, 0x003c, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0011, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6028, 0x0004, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60e5, 0x0013, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6088, 0x0014, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x600c, 0x002c, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6078, 0x0033, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60f7, 0x003b, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x003e, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6011, 0x0043, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6010, 0x0016, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6082, 0x0039, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6088, 0x0035, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x600a, 0x0022, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6040, 0x0037, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0023, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60a0, 0x0034, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x601a, 0x0036, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6002, 0x0006, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60c0, 0x0007, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60b7, 0x000d, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6001, 0x000e, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x004c, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6081, 0x004a, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6099, 0x0021, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6002, 0x0009, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x603e, 0x0024, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6034, 0x0025, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6081, 0x0026, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0000, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0045, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0010, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x005c, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0063, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x007c, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6070, 0x0061, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6080, 0x0062, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6080, 0x0020, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6030, 0x0028, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x006c, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x006e, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6002, 0x0070, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6094, 0x0071, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60c1, 0x0073, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6034, 0x003d, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6057, 0x005a, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60bb, 0x004f, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x609c, 0x0050, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6080, 0x006d, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6002, 0x0039, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6033, 0x003a, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60f1, 0x003b, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6031, 0x003c, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x00ff, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6014, 0x00e0, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60ff, 0x0076, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60a0, 0x0033, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6020, 0x0042, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6018, 0x0043, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x004c, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60d0, 0x0087, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x600f, 0x0088, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6003, 0x00d7, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6010, 0x00d9, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6005, 0x00da, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6082, 0x00d3, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60c0, 0x00f9, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6006, 0x0044, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6007, 0x00d1, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6002, 0x00d2, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x00d2, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6011, 0x00d8, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6008, 0x00c8, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6080, 0x00c9, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6008, 0x007c, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6020, 0x007d, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6020, 0x007d, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0090, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x600e, 0x0091, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x601a, 0x0091, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6031, 0x0091, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x605a, 0x0091, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6069, 0x0091, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6075, 0x0091, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x607e, 0x0091, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6088, 0x0091, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x608f, 0x0091, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6096, 0x0091, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60a3, 0x0091, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60af, 0x0091, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60c4, 0x0091, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60d7, 0x0091, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60e8, 0x0091, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6020, 0x0091, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0092, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6006, 0x0093, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60e3, 0x0093, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6005, 0x0093, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6005, 0x0093, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0093, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6004, 0x0093, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0093, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0093, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0093, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0093, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0093, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0093, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0093, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0096, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6008, 0x0097, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6019, 0x0097, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6002, 0x0097, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x600c, 0x0097, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6024, 0x0097, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6030, 0x0097, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6028, 0x0097, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6026, 0x0097, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6002, 0x0097, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6098, 0x0097, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6080, 0x0097, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0097, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0097, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60ed, 0x00c3, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x609a, 0x00c4, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x00a4, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6011, 0x00c5, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6051, 0x00c6, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6010, 0x00c7, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6066, 0x00b6, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60a5, 0x00b8, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6064, 0x00b7, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x607c, 0x00b9, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60af, 0x00b3, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6097, 0x00b4, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60ff, 0x00b5, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60c5, 0x00b0, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6094, 0x00b1, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x600f, 0x00b2, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x605c, 0x00c4, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x00a8, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60c8, 0x00c0, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6096, 0x00c1, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x601d, 0x0086, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0050, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6090, 0x0051, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6018, 0x0052, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0053, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0054, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6088, 0x0055, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0057, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6090, 0x005a, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6018, 0x005b, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6005, 0x005c, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60ed, 0x00c3, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x007f, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6005, 0x00da, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x601f, 0x00e5, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6067, 0x00e1, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x00e0, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60ff, 0x00dd, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0005, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6001, 0x00ff, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0000, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0045, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0010, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0006, 1, (void*)msi322);

	ctrl_out(dev, 0x40, 1, 0x00ef, 0x0006, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msi323);

	ctrl_out(dev, 0x40, 1, 0x0051, 0x0000, 0, NULL);
//	ctrl_out(dev, 0x40, 11, 0x0000, 0x0000, 0, NULL);


	STK_DEBUG("dev_0503ms_initialize_device [fini]\n");
	return 0;
}


/** 
 * @param dev Device structure
 * @param step The step of configuration [0-11]
 * 
 * @returns 0 if all is OK
 *
 * @brief This function permits to configure the device.
 *
 * The configuration of device is composed of 11 steps.
 * This function is called by the initialization process.
 *
 * We don't know the meaning of these steps ! We only replay the USB log.
 *
 * The steps 0 to 9 are called during the initialization.
 * Then, the driver choose the last step :
 *   10 : for a resolution from 80x60 to 640x480 
 *   11 : for a resolution from 800x600 to 1280x1024
 */
int dev_0503ms_configure_device(struct usb_gl860 *dev, int step)
{
	return 0;
}


/** 
 * @param dev Device structure
 * 
 * @returns 0 if all is OK
 *
 * @brief Wake-up the camera.
 *
 * This function permits to wake-up the device.
 */
int dev_0503ms_camera_asleep(struct usb_gl860 *dev)
{
	return 0;
}


/** 
 * @param dev Device structure
 * 
 * @returns 0 if all is OK
 *
 * @brief This function initializes the device for the stream.
 *
 * It's the start. This function has to be called at first, before
 * enabling the video stream.
 */
int dev_0503ms_init_camera(struct usb_gl860 *dev)
{
	STK_DEBUG("dev_0503ms_init_stream [ini]\n");
/*
	ctrl_out(dev, 0x40, 5, 0x0001, 0x0000, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x0041, 0x0000, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x006a, 0x0007, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x0061, 0x0006, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x006a, 0x000d, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x0000, 0x00c0, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x0010, 0x0010, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x0001, 0x00c1, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x0041, 0x00c2, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x0004, 0x00d8, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x0012, 0x0004, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x0000, 0x0058, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x0041, 0x0000, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x0061, 0x0000, 0, NULL);
	ctrl_out(dev, 0x40, 3, 0x0000, 0x0200, 12, (void*)msc000);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x00ff, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60ff, 0x002c, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60df, 0x002e, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6001, 0x00ff, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6080, 0x0012, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0000, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0045, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0010, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6035, 0x003c, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0011, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6028, 0x0004, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60e5, 0x0013, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6088, 0x0014, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x600c, 0x002c, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6078, 0x0033, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60f7, 0x003b, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x003e, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6011, 0x0043, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6010, 0x0016, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6082, 0x0039, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6088, 0x0035, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x600a, 0x0022, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6040, 0x0037, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0023, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60a0, 0x0034, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x601a, 0x0036, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6002, 0x0006, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60c0, 0x0007, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60b7, 0x000d, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6001, 0x000e, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x004c, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6081, 0x004a, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6099, 0x0021, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6002, 0x0009, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x603e, 0x0024, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6034, 0x0025, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6081, 0x0026, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0000, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0045, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0010, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x005c, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0063, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x007c, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6070, 0x0061, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6080, 0x0062, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6080, 0x0020, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6030, 0x0028, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x006c, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x006e, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6002, 0x0070, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6094, 0x0071, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60c1, 0x0073, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6034, 0x003d, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6057, 0x005a, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60bb, 0x004f, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x609c, 0x0050, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6080, 0x006d, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6002, 0x0039, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6033, 0x003a, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60f1, 0x003b, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6031, 0x003c, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x00ff, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6014, 0x00e0, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60ff, 0x0076, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60a0, 0x0033, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6020, 0x0042, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6018, 0x0043, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x004c, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60d0, 0x0087, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x600f, 0x0088, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6003, 0x00d7, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6010, 0x00d9, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6005, 0x00da, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6082, 0x00d3, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60c0, 0x00f9, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6006, 0x0044, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6007, 0x00d1, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6002, 0x00d2, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x00d2, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6011, 0x00d8, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6008, 0x00c8, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6080, 0x00c9, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6008, 0x007c, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6020, 0x007d, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6020, 0x007d, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0090, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x600e, 0x0091, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x601a, 0x0091, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6031, 0x0091, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x605a, 0x0091, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6069, 0x0091, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6075, 0x0091, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x607e, 0x0091, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6088, 0x0091, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x608f, 0x0091, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6096, 0x0091, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60a3, 0x0091, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60af, 0x0091, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60c4, 0x0091, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60d7, 0x0091, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60e8, 0x0091, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6020, 0x0091, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0092, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6006, 0x0093, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60e3, 0x0093, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6005, 0x0093, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6005, 0x0093, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0093, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6004, 0x0093, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0093, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0093, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0093, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0093, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0093, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0093, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0093, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0096, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6008, 0x0097, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6019, 0x0097, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6002, 0x0097, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x600c, 0x0097, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6024, 0x0097, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6030, 0x0097, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6028, 0x0097, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6026, 0x0097, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6002, 0x0097, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6098, 0x0097, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6080, 0x0097, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0097, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0097, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60ed, 0x00c3, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x609a, 0x00c4, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x00a4, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6011, 0x00c5, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6051, 0x00c6, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6010, 0x00c7, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6066, 0x00b6, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60a5, 0x00b8, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6064, 0x00b7, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x607c, 0x00b9, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60af, 0x00b3, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6097, 0x00b4, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60ff, 0x00b5, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60c5, 0x00b0, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6094, 0x00b1, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x600f, 0x00b2, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x605c, 0x00c4, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x00a8, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60c8, 0x00c0, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6096, 0x00c1, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x601d, 0x0086, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0050, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6090, 0x0051, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6018, 0x0052, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0053, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0054, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6088, 0x0055, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0057, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6090, 0x005a, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6018, 0x005b, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6005, 0x005c, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60ed, 0x00c3, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x007f, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6005, 0x00da, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x601f, 0x00e5, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6067, 0x00e1, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x00e0, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60ff, 0x00dd, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0005, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6001, 0x00ff, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0000, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0045, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0010, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0006, 1, (void*)msc001);

	ctrl_out(dev, 0x40, 1, 0x00ef, 0x0006, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msc002);

	ctrl_out(dev, 0x40, 1, 0x0051, 0x0000, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msc003);

	ctrl_out(dev, 0x40, 1, 0x0050, 0x0000, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x00ff, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60f1, 0x00dd, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6004, 0x00e0, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6067, 0x00e1, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6004, 0x00da, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x00ff, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60f1, 0x00dd, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6004, 0x00e0, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6001, 0x00ff, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0012, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0011, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6011, 0x0017, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6075, 0x0018, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6001, 0x0019, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6097, 0x001a, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6036, 0x0032, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60bb, 0x004f, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6057, 0x005a, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x609c, 0x0050, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6080, 0x006d, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6092, 0x0026, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60ff, 0x0020, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0027, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x00ff, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60c8, 0x00c0, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6096, 0x00c1, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x008c, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x603d, 0x0086, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6089, 0x0050, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6090, 0x0051, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x602c, 0x0052, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0053, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0054, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6088, 0x0055, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0057, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60a0, 0x005a, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6078, 0x005b, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x005c, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6004, 0x00d3, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x00e0, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60ff, 0x00dd, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60a1, 0x005a, 0, NULL);
	ctrl_out(dev, 0x40, 3, 0x0000, 0x0200, 12, (void*)msc004);
	ctrl_out(dev, 0x40, 1, 0x6001, 0x00ff, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6038, 0x000c, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6001, 0x00ff, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0011, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x603e, 0x0024, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6034, 0x0025, 0, NULL);

	ctrl_out(dev, 0x40, 1, 0x6001, 0x00ff, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x8004, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x6000, 0x8004, 1, (void*)msc006);

	ctrl_out(dev, 0x40, 1, 0x60a8, 0x0004, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6001, 0x00ff, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x8004, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x6000, 0x8004, 1, (void*)msc007);

	ctrl_out(dev, 0x40, 1, 0x60f8, 0x0004, 0, NULL);

// après chaque image
//	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)msc008);
*/
	STK_DEBUG("dev_0503ms_init_stream [appel a sensor_settings]\n");

//	dev_0503ms_sensor_settings(dev);

	STK_DEBUG("dev_0503ms_init_stream [fini]\n");
	return 0;
}


/** 
 * @param dev Device structure
 * 
 * @returns 0 if all is OK
 *
 * @brief This function permits to set default sensor settings.
 *
 * We set some registers in using a I2C bus.
 * WARNING, the sensor settings can be different following the situation.
 */
int dev_0503ms_sensor_settings(struct usb_gl860 *dev)
{
	excj   = -1;
	exnet  = -1;
	exsat  = -1;
	excoul = -1;
	exsrc  = -1;
	excntr = -1;
	exgam  = -1;
	exlum  = -1;

	ctrl_out(dev, 0x40, 5, 0x0001, 0x0000, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x0041, 0x0000, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x006a, 0x0007, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x00ef, 0x0006, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x006a, 0x000d, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x0000, 0x00c0, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x0010, 0x0010, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x0001, 0x00c1, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x0041, 0x00c2, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x0004, 0x00d8, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x0012, 0x0004, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x0000, 0x0058, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x0041, 0x0000, 0, NULL);
	msleep(50);
	ctrl_out(dev, 0x40, 1, 0x0061, 0x0000, 0, NULL);
	ctrl_out(dev, 0x40, 3, 0x0000, 0x0200, 12, (void*)mscommun);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x00ff, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60ff, 0x002c, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60df, 0x002e, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6001, 0x00ff, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6080, 0x0012, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0000, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0045, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0010, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6035, 0x003c, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0011, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6028, 0x0004, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60e5, 0x0013, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6088, 0x0014, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x600c, 0x002c, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6078, 0x0033, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60f7, 0x003b, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x003e, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6011, 0x0043, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6010, 0x0016, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6082, 0x0039, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6088, 0x0035, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x600a, 0x0022, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6040, 0x0037, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0023, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60a0, 0x0034, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x601a, 0x0036, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6002, 0x0006, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60c0, 0x0007, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60b7, 0x000d, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6001, 0x000e, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x004c, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6081, 0x004a, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6099, 0x0021, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6002, 0x0009, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x603e, 0x0024, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6034, 0x0025, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6081, 0x0026, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0000, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0045, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0010, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x005c, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0063, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x007c, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6070, 0x0061, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6080, 0x0062, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6080, 0x0020, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6030, 0x0028, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x006c, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x006e, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6002, 0x0070, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6094, 0x0071, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60c1, 0x0073, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6034, 0x003d, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6057, 0x005a, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60bb, 0x004f, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x609c, 0x0050, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6080, 0x006d, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6002, 0x0039, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6033, 0x003a, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60f1, 0x003b, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6031, 0x003c, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x00ff, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6014, 0x00e0, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60ff, 0x0076, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60a0, 0x0033, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6020, 0x0042, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6018, 0x0043, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x004c, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60d0, 0x0087, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x600f, 0x0088, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6003, 0x00d7, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6010, 0x00d9, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6005, 0x00da, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6082, 0x00d3, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60c0, 0x00f9, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6006, 0x0044, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6007, 0x00d1, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6002, 0x00d2, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x00d2, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6011, 0x00d8, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6008, 0x00c8, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6080, 0x00c9, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6008, 0x007c, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6020, 0x007d, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6020, 0x007d, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0090, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x600e, 0x0091, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x601a, 0x0091, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6031, 0x0091, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x605a, 0x0091, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6069, 0x0091, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6075, 0x0091, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x607e, 0x0091, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6088, 0x0091, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x608f, 0x0091, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6096, 0x0091, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60a3, 0x0091, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60af, 0x0091, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60c4, 0x0091, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60d7, 0x0091, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60e8, 0x0091, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6020, 0x0091, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0092, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6006, 0x0093, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60e3, 0x0093, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6005, 0x0093, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6005, 0x0093, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0093, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6004, 0x0093, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0093, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0093, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0093, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0093, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0093, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0093, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0093, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0096, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6008, 0x0097, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6019, 0x0097, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6002, 0x0097, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x600c, 0x0097, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6024, 0x0097, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6030, 0x0097, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6028, 0x0097, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6026, 0x0097, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6002, 0x0097, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6098, 0x0097, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6080, 0x0097, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0097, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0097, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60ed, 0x00c3, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x609a, 0x00c4, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x00a4, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6011, 0x00c5, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6051, 0x00c6, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6010, 0x00c7, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6066, 0x00b6, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60a5, 0x00b8, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6064, 0x00b7, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x607c, 0x00b9, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60af, 0x00b3, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6097, 0x00b4, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60ff, 0x00b5, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60c5, 0x00b0, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6094, 0x00b1, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x600f, 0x00b2, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x605c, 0x00c4, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x00a8, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60c8, 0x00c0, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6096, 0x00c1, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x601d, 0x0086, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0050, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6090, 0x0051, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6018, 0x0052, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0053, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0054, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6088, 0x0055, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0057, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6090, 0x005a, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6018, 0x005b, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6005, 0x005c, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60ed, 0x00c3, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x007f, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6005, 0x00da, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x601f, 0x00e5, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6067, 0x00e1, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x00e0, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x60ff, 0x00dd, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0005, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6001, 0x00ff, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0000, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0045, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0010, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x00ff, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x007c, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6007, 0x007d, 0, NULL);
	msleep(30);
	ctrl_out(dev, 0x40, 1, 0x0040, 0x0000, 0, NULL);

   switch (dev->resolution) {
		case WCAM_640x480:
		case WCAM_320x240:
		case WCAM_160x120:
		case WCAM_213x160:
		case WCAM_128x96:
		case WCAM_80x60:
			dev->lealt=3;
			ctrl_out(dev, 0x40, 1, 0x6000, 0x00ff, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x60f1, 0x00dd, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6004, 0x00e0, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6067, 0x00e1, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6004, 0x00da, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x00ff, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x60f1, 0x00dd, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6004, 0x00e0, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6001, 0x00ff, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x0012, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x0011, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6011, 0x0017, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6075, 0x0018, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6001, 0x0019, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6097, 0x001a, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6036, 0x0032, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x60bb, 0x004f, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6057, 0x005a, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x609c, 0x0050, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6080, 0x006d, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6092, 0x0026, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x60ff, 0x0020, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x0027, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x00ff, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x60c8, 0x00c0, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6096, 0x00c1, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x008c, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x603d, 0x0086, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6089, 0x0050, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6090, 0x0051, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x602c, 0x0052, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x0053, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x0054, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6088, 0x0055, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x0057, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x60a0, 0x005a, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6078, 0x005b, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x005c, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6004, 0x00d3, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x00e0, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x60ff, 0x00dd, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x60a1, 0x005a, 0, NULL);
			ctrl_out(dev, 0x40, 3, 0x0000, 0x0200, 12, (void*)ms640);
			break;

		case WCAM_800x600:
			dev->lealt=1;
			ctrl_out(dev, 0x40, 1, 0x6000, 0x00ff, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x60f1, 0x00dd, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6004, 0x00e0, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6067, 0x00e1, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6004, 0x00da, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x00ff, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x60f1, 0x00dd, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6004, 0x00e0, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6001, 0x00ff, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6040, 0x0012, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x0011, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6011, 0x0017, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6043, 0x0018, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x0019, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x604b, 0x001a, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6009, 0x0032, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x60ca, 0x004f, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x60a8, 0x0050, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x006d, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6038, 0x003d, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x60c8, 0x0035, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x0022, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6092, 0x0026, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x60ff, 0x0020, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x0027, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x00ff, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6064, 0x00c0, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x604b, 0x00c1, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x008c, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x601d, 0x0086, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6082, 0x00d3, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x00e0, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x60ff, 0x00dd, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6020, 0x008c, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6001, 0x00ff, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6044, 0x0018, 0, NULL);
			ctrl_out(dev, 0x40, 3, 0x0000, 0x0200, 12, (void*)ms800);
			break;

      case WCAM_1280x960:
			dev->lealt=1;
			ctrl_out(dev, 0x40, 1, 0x0002, 0x00c1, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x00ff, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x60f1, 0x00dd, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6004, 0x00e0, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6001, 0x00ff, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x0012, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x0000, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x0045, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x0010, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x0011, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6011, 0x0017, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6075, 0x0018, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6001, 0x0019, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6097, 0x001a, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6036, 0x0032, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x60bb, 0x004f, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x609c, 0x0050, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6057, 0x005a, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6080, 0x006d, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6043, 0x000f, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x608f, 0x0003, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6005, 0x007c, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6081, 0x0026, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x00ff, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x60c8, 0x00c0, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6096, 0x00c1, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x008c, 0, NULL);
			//+1280
			ctrl_out(dev, 0x40, 1, 0x603d, 0x0086, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x0050, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6090, 0x0051, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x602c, 0x0052, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x0053, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x0054, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6088, 0x0055, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x0057, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6040, 0x005a, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x60f0, 0x005b, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6001, 0x005c, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6082, 0x00d3, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x008e, 0, NULL);
			//fin +1280
			ctrl_out(dev, 0x40, 1, 0x6004, 0x00da, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x00e0, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6067, 0x00e1, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x60ff, 0x00dd, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6001, 0x00ff, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x00ff, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x60f1, 0x00dd, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6004, 0x00e0, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6001, 0x00ff, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x0011, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x00ff, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6010, 0x00c7, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x0092, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6006, 0x0093, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x60e3, 0x0093, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6005, 0x0093, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6005, 0x0093, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x60ed, 0x00c3, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x00a4, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x60d0, 0x0087, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6003, 0x0096, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x600c, 0x0097, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6024, 0x0097, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6030, 0x0097, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6028, 0x0097, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6026, 0x0097, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6002, 0x0097, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6001, 0x00ff, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6043, 0x000f, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x608f, 0x0003, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x002d, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x002e, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x600a, 0x0022, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6002, 0x0070, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6008, 0x0014, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6048, 0x0014, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x00ff, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x00e0, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x60ff, 0x00dd, 0, NULL);
			//+1280
			ctrl_out(dev, 0x40, 1, 0x6001, 0x00ff, 0, NULL);
			ctrl_out(dev, 0x40, 3, 0x0000, 0x0200, 12, (void*)ms1280);
			break;

		case WCAM_1600x1200:
			dev->lealt=1;
			ctrl_out(dev, 0x40, 1, 0x0002, 0x00c1, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x00ff, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x60f1, 0x00dd, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6004, 0x00e0, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6001, 0x00ff, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x0012, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x0000, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x0045, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x0010, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x0011, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6011, 0x0017, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6075, 0x0018, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6001, 0x0019, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6097, 0x001a, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6036, 0x0032, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x60bb, 0x004f, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x609c, 0x0050, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6057, 0x005a, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6080, 0x006d, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6043, 0x000f, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x608f, 0x0003, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6005, 0x007c, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6081, 0x0026, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x00ff, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x60c8, 0x00c0, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6096, 0x00c1, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x008c, 0, NULL);
			//+1600
			ctrl_out(dev, 0x40, 1, 0x601d, 0x0086, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6001, 0x00d7, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6082, 0x00d3, 0, NULL);
			//fin+
			ctrl_out(dev, 0x40, 1, 0x6004, 0x00da, 0, NULL);//début commun avec 1280
			ctrl_out(dev, 0x40, 1, 0x6000, 0x00e0, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6067, 0x00e1, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x60ff, 0x00dd, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6001, 0x00ff, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x00ff, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x60f1, 0x00dd, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6004, 0x00e0, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6001, 0x00ff, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x0011, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x00ff, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6010, 0x00c7, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x0092, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6006, 0x0093, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x60e3, 0x0093, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6005, 0x0093, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6005, 0x0093, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x60ed, 0x00c3, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x00a4, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x60d0, 0x0087, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6003, 0x0096, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x600c, 0x0097, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6024, 0x0097, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6030, 0x0097, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6028, 0x0097, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6026, 0x0097, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6002, 0x0097, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6001, 0x00ff, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6043, 0x000f, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x608f, 0x0003, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x002d, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x002e, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x600a, 0x0022, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6002, 0x0070, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6008, 0x0014, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6048, 0x0014, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x00ff, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6000, 0x00e0, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x60ff, 0x00dd, 0, NULL);
			//+1600
			ctrl_out(dev, 0x40, 1, 0x6020, 0x008c, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6001, 0x00ff, 0, NULL);
			ctrl_out(dev, 0x40, 1, 0x6076, 0x0018, 0, NULL);
			ctrl_out(dev, 0x40, 3, 0x0000, 0x0200, 12, (void*)ms1600);
			break;
	}

// COMMUN
	ctrl_out(dev, 0x40, 1, 0x6001, 0x00ff, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6038, 0x000c, 0, NULL);
	msleep(10);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x0011, 0, NULL);//en dessous avant
	ctrl_out(dev, 0x40, 1, 0x6001, 0x00ff, 0, NULL);//au dessus avant//c
	ctrl_out(dev, 0x40, 1, 0x603e, 0x0024, 0, NULL);//c
	ctrl_out(dev, 0x40, 1, 0x6034, 0x0025, 0, NULL);//cj=31/64

	ctrl_out(dev, 0x40, 1, 0x6000, 0x00ff, 0, NULL);//l
	ctrl_out(dev, 0x40, 1, 0x6009, 0x007c, 0, NULL);//l
	ctrl_out(dev, 0x40, 1, 0x6000, 0x007d, 0, NULL);//lum=0/256
	ctrl_out(dev, 0x40, 1, 0x6000, 0x00ff, 0, NULL);//s
	ctrl_out(dev, 0x40, 1, 0x6003, 0x007c, 0, NULL);//s
	ctrl_out(dev, 0x40, 1, 0x6040, 0x007d, 0, NULL);//src=64/128
	ctrl_out(dev, 0x40, 1, 0x6000, 0x00ff, 0, NULL);//c
	ctrl_out(dev, 0x40, 1, 0x6007, 0x007c, 0, NULL);//c
	ctrl_out(dev, 0x40, 1, 0x6000, 0x007d, 0, NULL);//cntr=0/256
	ctrl_out(dev, 0x40, 1, 0x6000, 0x00ff, 0, NULL);//s
	ctrl_out(dev, 0x40, 1, 0x6001, 0x007c, 0, NULL);//s
	ctrl_out(dev, 0x40, 1, 0x6080, 0x007d, 0, NULL);//sat=128/256
	ctrl_out(dev, 0x40, 1, 0x6000, 0x00ff, 0, NULL);//n
	ctrl_out(dev, 0x40, 1, 0x6001, 0x0092, 0, NULL);//n
	ctrl_out(dev, 0x40, 1, 0x60c0, 0x0093, 0, NULL);//net=0/32
	ctrl_out(dev, 0x40, 1, 0x6000, 0x00ff, 0, NULL);//c
	ctrl_out(dev, 0x40, 1, 0x6002, 0x007c, 0, NULL);//c
	ctrl_out(dev, 0x40, 1, 0x6000, 0x007d, 0, NULL);//coul=0/256
	ctrl_out(dev, 0x40, 1, 0x6000, 0x00ff, 0, NULL);//g
	ctrl_out(dev, 0x40, 1, 0x6008, 0x007c, 0, NULL);//g
	ctrl_out(dev, 0x40, 1, 0x6020, 0x007d, 0, NULL);//gam=32/64

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)ms50);//droit

	msleep(15);
	ctrl_out(dev, 0x40, 1, 0x6001, 0x00ff, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x8004, 0, NULL);
	ctrl_in(dev, 0xc0, 2, 0x6000, 0x8004, 1, (void*)ms28);
	ctrl_out(dev, 0x40, 1, 0x60a8, 0x0004, 0, NULL);

	msleep(15);
	ctrl_out(dev, 0x40, 1, 0x6001, 0x00ff, 0, NULL);
	ctrl_out(dev, 0x40, 1, 0x6000, 0x8004, 0, NULL);
	ctrl_in(dev, 0xc0, 2, 0x6000, 0x8004, 1, (void*)msa8);
	ctrl_out(dev, 0x40, 1, 0x60f8, 0x0004, 0, NULL);

	ctrl_in(dev, 0xc0, 2, 0x0000, 0x0000, 1, (void*)ms50);//droit

	ctrl_out(dev, 0x40, 1, 0x6001, 0x00ff, 0, NULL);//c
	ctrl_out(dev, 0x40, 1, 0x603e, 0x0024, 0, NULL);//c
	ctrl_out(dev, 0x40, 1, 0x6034, 0x0025, 0, NULL);//cj=31/64

	return 0;
}


/** 
 * @param dev Device structure
 * 
 * @returns 0 if all is OK
 *
 * @brief This function permits to modify the settings of the camera.
 *
 * This functions permits to modify the settings :
 *   - brightness
 *   - contrast
 *   - white balance
 *   - ...
 */
int dev_0503ms_camera_settings(struct usb_gl860 *dev)
{
	int cj   =dev->vsettings.contrej;
	int net  =dev->vsettings.net;
	int sat  =dev->vsettings.saturation;
	int coul =dev->vsettings.colour;
	int src  =dev->vsettings.srclum;
	int cntr =dev->vsettings.contrast;
	int gam  =dev->vsettings.whiteness;
	int lum  =dev->vsettings.brightness;

	cj/=256*(256/64);
	net/=256*(256/32);
	sat/=256;
	coul/=256;
	src/=256*(256/128);
	cntr/=256;
	gam/=256*(256/64);
	lum/=256;

	STK_DEBUG("dev_0503ms_camera_settings [ini]\n");

	// Ordre du pilote écouté
	
	if (cj!=excj)
	{
		if (cj<0) cj=0;
		ctrl_out(dev, 0x40, 1, 0x6001      , 0x00ff, 0, NULL);
		ctrl_out(dev, 0x40, 1, 0x601f+cj   , 0x0024, 0, NULL);
		ctrl_out(dev, 0x40, 1, 0x601f+cj-10, 0x0025, 0, NULL);
	}

	if (lum!=exlum)
	{
		if (lum<0) lum=0;
		ctrl_out(dev, 0x40, 1, 0x6000    , 0x00ff, 0, NULL);
		ctrl_out(dev, 0x40, 1, 0x6009    , 0x007c, 0, NULL);
		ctrl_out(dev, 0x40, 1, 0x6000+lum, 0x007d, 0, NULL);
		exlum=lum;
	}

	if (src!=exsrc)
	{
		if (src<0) src=0;
		ctrl_out(dev, 0x40, 1, 0x6000    , 0x00ff, 0, NULL);
		ctrl_out(dev, 0x40, 1, 0x6003    , 0x007c, 0, NULL);
		ctrl_out(dev, 0x40, 1, 0x6000+src, 0x007d, 0, NULL);
		exsrc=src;
	}

	if (cntr!=excntr)
	{
		if (cntr<0) cntr=0;
		ctrl_out(dev, 0x40, 1, 0x6000     , 0x00ff, 0, NULL);
		ctrl_out(dev, 0x40, 1, 0x6007     , 0x007c, 0, NULL);
		ctrl_out(dev, 0x40, 1, 0x6000+cntr, 0x007d, 0, NULL);
		excntr=cntr;
	}

	if (sat!=exsat)
	{
		if (sat<0) sat=0;
		ctrl_out(dev, 0x40, 1, 0x6000    , 0x00ff, 0, NULL);
		ctrl_out(dev, 0x40, 1, 0x6001    , 0x007c, 0, NULL);
		ctrl_out(dev, 0x40, 1, 0x6000+sat, 0x007d, 0, NULL);
		exsat=sat;
	}

	if (net!=exnet)
	{
		if (net<0) net=0;
		ctrl_out(dev, 0x40, 1, 0x6000    , 0x00ff, 0, NULL);
		ctrl_out(dev, 0x40, 1, 0x6001    , 0x0092, 0, NULL);
		ctrl_out(dev, 0x40, 1, 0x60c0+net, 0x0093, 0, NULL);
		exnet=net;
	}

	if (coul!=excoul)
	{
		if (coul<0) coul=0;
		ctrl_out(dev, 0x40, 1, 0x6000     , 0x00ff, 0, NULL);
		ctrl_out(dev, 0x40, 1, 0x6002     , 0x007c, 0, NULL);
		ctrl_out(dev, 0x40, 1, 0x6000+coul, 0x007d, 0, NULL);
		excoul=coul;
	}

	if (gam!=exgam)
	{
		if (gam<0) gam=0;
		ctrl_out(dev, 0x40, 1, 0x6000    , 0x00ff, 0, NULL);
		ctrl_out(dev, 0x40, 1, 0x6008    , 0x007c, 0, NULL);
		ctrl_out(dev, 0x40, 1, 0x6000+gam, 0x007d, 0, NULL);
		exgam=gam;
	}

	if (cj!=excj)
	{
		if (cj<0) cj=0;
		ctrl_out(dev, 0x40, 1, 0x6001      , 0x00ff, 0, NULL);
		ctrl_out(dev, 0x40, 1, 0x601f+cj   , 0x0024, 0, NULL);
		ctrl_out(dev, 0x40, 1, 0x601f+cj-10, 0x0025, 0, NULL);
		excj=cj;
	}

	STK_DEBUG("dev_0503ms_camera_settings [fini]\n");

	return 0;
}


/** 
 * @param dev Device structure
 * 
 * @returns 0 if all is OK
 *
 * @brief This function permits to modify the settings of the camera.
 *
 * This functions permits to modify the settings :
 *   - brightness
 *   - contrast
 *   - white balance
 *   - ...
 *
 */
int dev_0503ms_set_camera_quality(struct usb_gl860 *dev)
{
	return 0;
}


/** 
 * @param dev Device structure
 * 
 * @returns 0 if all is OK
 *
 * @brief This function permits to modify the settings of the camera.
 *
 * This functions permits to modify the frame rate per second.
 *
 */
int dev_0503ms_set_camera_fps(struct usb_gl860 *dev)
{
	return 0;
}


/** 
 * @param dev Device structure
 * 
 * @returns 0 if all is OK
 *
 * @brief This function sets the device to start the stream.
 *
 * After the initialization of the device and the initialization of the video stream,
 * this function permits to enable the stream.
 */
int dev_0503ms_start_stream(struct usb_gl860 *dev)
{

	dev_0503ms_sensor_settings(dev);

	return 0;
}


/** 
 * @param dev Device structure
 * 
 * @returns 0 if all is OK
 *
 * @brief Reconfigure the camera before the stream.
 *
 * Before enabling the video stream, you have to reconfigure the device.
 */
int dev_0503ms_reconf_camera(struct usb_gl860 *dev)
{
   switch (dev->resolution) {
		case WCAM_640x480:
		case WCAM_320x240:
		case WCAM_160x120:
		case WCAM_213x160:
		case WCAM_128x96:
		case WCAM_80x60:
			dev->lealt=3;
			dev->offset=2048;
			dev->nbPaq=32;
			break;

		case WCAM_800x600:
			dev->lealt=1;
			dev->offset=3072;
			dev->nbPaq=32;
			break;

		case WCAM_1280x960:
			dev->lealt=1;
			dev->offset=3072;
			dev->nbPaq=32;
			break;

		case WCAM_1600x1200:
			dev->lealt=1;
			dev->offset=3072;
			dev->nbPaq=32;
			break;
	}

	return 0;
}


/** 
 * @param dev Device structure
 * 
 * @returns 0 if all is OK
 *
 * @brief This function sets the device to stop the stream.
 *
 * You use the function start_stream to enable the video stream. So you
 * have to use the function stop_strem to disable the video stream.
 */
int dev_0503ms_stop_stream(struct usb_gl860 *dev)
{
	STK_DEBUG("dev_0503ms_stop_stream [ini]\n");

   ctrl_out(dev, 0x40, 5, 0x0000, 0x0000, 0, NULL);
	msleep(20);
   ctrl_out(dev, 0x40, 1, 0x006a, 0x000d, 0, NULL); //
   ctrl_out(dev, 0x40, 1, 0x6001, 0x00ff, 0, NULL);
   ctrl_out(dev, 0x40, 1, 0x6081, 0x0026, 0, NULL);
   ctrl_out(dev, 0x40, 1, 0x6000, 0x0000, 0, NULL);
   ctrl_out(dev, 0x40, 1, 0x6000, 0x0045, 0, NULL);
   ctrl_out(dev, 0x40, 1, 0x6000, 0x0010, 0, NULL);
   ctrl_out(dev, 0x40, 1, 0x6068, 0x000d, 0, NULL); //
	msleep(50);
   ctrl_out(dev, 0x40, 1, 0x0021, 0x0000, 0, NULL);

	STK_DEBUG("dev_0503ms_stop_stream [fini]\n");
	return 0;
}

